pcl::PointCloud< PointT > Class Template Reference

PointCloud represents the base class in PCL for storing collections of 3D points. More...

`#include <pcl/common/projection_matrix.h>`

## Public Types

typedef PointT | PointType
typedef std::vector< PointT, Eigen::aligned_allocator< PointT > > | VectorType
typedef std::vector< PointCloud< PointT >, Eigen::aligned_allocator< PointCloud< PointT > > > | CloudVectorType
typedef boost::shared_ptr< PointCloud< PointT > > | Ptr
typedef boost::shared_ptr< const PointCloud< PointT > > | ConstPtr
typedef VectorType::iterator | iterator
typedef VectorType::const_iterator | const_iterator

## Public Member Functions

| PointCloud ()
| Default constructor. More...
| PointCloud (PointCloud< PointT > &pc)
| Copy constructor (needed by compilers such as Intel C++) More...
| PointCloud (const PointCloud< PointT > &pc)
| Copy constructor (needed by compilers such as Intel C++) More...
| PointCloud (const PointCloud< PointT > &pc, const std::vector< int > &indices)
| Copy constructor from point cloud subset. More...
| PointCloud (uint32_t width_, uint32_t height_, const PointT &value_=PointT())
| Allocate constructor from point cloud subset. More...
virtual | ~PointCloud ()
| Destructor. More...
PointCloud & | operator+= (const PointCloud &rhs)
| Add a point cloud to the current cloud. More...
const PointCloud | operator+ (const PointCloud &rhs)
| Add a point cloud to another cloud. More...
const PointT & | at (int column, int row) const
| Obtain the point given by the (column, row) coordinates. More...
PointT & | at (int column, int row)
| Obtain the point given by the (column, row) coordinates. More...
const PointT & | operator() (size_t column, size_t row) const
| Obtain the point given by the (column, row) coordinates. More...
PointT & | operator() (size_t column, size_t row)
| Obtain the point given by the (column, row) coordinates. More...
bool | isOrganized () const
| Return whether a dataset is organized (e.g., arranged in a structured grid). More...
Eigen::Map< Eigen::MatrixXf, Eigen::Aligned, Eigen::OuterStride<> > | getMatrixXfMap (int dim, int stride, int offset)
| Return an Eigen MatrixXf (assumes float values) mapped to the specified dimensions of the PointCloud. More...
const Eigen::Map< const Eigen::MatrixXf, Eigen::Aligned, Eigen::OuterStride<> > | getMatrixXfMap (int dim, int stride, int offset) const
| Return an Eigen MatrixXf (assumes float values) mapped to the specified dimensions of the PointCloud. More...
Eigen::Map< Eigen::MatrixXf, Eigen::Aligned, Eigen::OuterStride<> > | getMatrixXfMap ()
| Return an Eigen MatrixXf (assumes float values) mapped to the PointCloud. More...
const Eigen::Map< const Eigen::MatrixXf, Eigen::Aligned, Eigen::OuterStride<> > | getMatrixXfMap () const
| Return an Eigen MatrixXf (assumes float values) mapped to the PointCloud. More...
iterator | begin ()
iterator | end ()
const_iterator | begin () const
const_iterator | end () const
size_t | size () const
void | reserve (size_t n)
bool | empty () const
void | resize (size_t n)
| Resize the cloud. More...
const PointT & | operator[] (size_t n) const
PointT & | operator[] (size_t n)
const PointT & | at (size_t n) const
PointT & | at (size_t n)
const PointT & | front () const
PointT & | front ()
const PointT & | back () const
PointT & | back ()
void | push_back (const PointT &pt)
| Insert a new point in the cloud, at the end of the container. More...
iterator | insert (iterator position, const PointT &pt)
| Insert a new point in the cloud, given an iterator. More...
void | insert (iterator position, size_t n, const PointT &pt)
| Insert a new point in the cloud N times, given an iterator. More...
template<class InputIterator >
void | insert (iterator position, InputIterator first, InputIterator last)
| Insert a new range of points in the cloud, at a certain position. More...
iterator | erase (iterator position)
| Erase a point in the cloud. More...
iterator | erase (iterator first, iterator last)
| Erase a set of points given by a (first, last) iterator pair. More...
void | swap (PointCloud< PointT > &rhs)
| Swap a point cloud with another cloud. More...
void | clear ()
| Removes all points in a cloud and sets the width and height to 0. More...
Ptr | makeShared () const
| Copy the cloud to the heap and return a smart pointer Note that deep copy is performed, so avoid using this function on non-empty clouds. More...

## Public Attributes

pcl::PCLHeader | header
| The point cloud header. More...
std::vector< PointT, Eigen::aligned_allocator< PointT > > | points
| The point data. More...
uint32_t | width
| The point cloud width (if organized as an image-structure). More...
uint32_t | height
| The point cloud height (if organized as an image-structure). More...
bool | is_dense
| True if no points are invalid (e.g., have NaN or Inf values). More...
Eigen::Vector4f | sensor_origin_
| Sensor acquisition pose (origin/translation). More...
Eigen::Quaternionf | sensor_orientation_
| Sensor acquisition pose (rotation). More...

## Protected Attributes

boost::shared_ptr< MsgFieldMap > | mapping_

## Friends

boost::shared_ptr< MsgFieldMap > & | detail::getMapping (pcl::PointCloud< PointT > &p)

## Detailed Description

### template<typename PointT>
class pcl::PointCloud< PointT >

PointCloud represents the base class in PCL for storing collections of 3D points.

The class is templated, which means you need to specify the type of data that it should contain. For example, to create a point cloud that holds 4 random XYZ data points, use:

pcl::PointCloud<pcl::PointXYZ> cloud;
cloud.push_back (pcl::PointXYZ (rand (), rand (), rand ()));
cloud.push_back (pcl::PointXYZ (rand (), rand (), rand ()));
cloud.push_back (pcl::PointXYZ (rand (), rand (), rand ()));
cloud.push_back (pcl::PointXYZ (rand (), rand (), rand ()));

The PointCloud class contains the following elements:

- width - specifies the width of the point cloud dataset in the number of points. WIDTH has two meanings:
  - it can specify the total number of points in the cloud (equal with POINTS see below) for unorganized datasets;
  - it can specify the width (total number of points in a row) of an organized point cloud dataset. Mandatory.
- height - specifies the height of the point cloud dataset in the number of points. HEIGHT has two meanings:
  - it can specify the height (total number of rows) of an organized point cloud dataset;
  - it is set to 1 for unorganized datasets (thus used to check whether a dataset is organized or not). Mandatory.
- points - the data array where all points of type PointT are stored. Mandatory.
- is_dense - specifies if all the data in points is finite (true), or whether it might contain Inf/NaN values (false). Mandatory.
- sensor_origin_ - specifies the sensor acquisition pose (origin/translation). Optional.
- sensor_orientation_ - specifies the sensor acquisition pose (rotation). Optional.

Author
  Patrick Mihelich, Radu B. Rusu

Definition at line 53 of file projection_matrix.h.

## Member Typedef Documentation

template<typename PointT>

typedef std::vector<PointCloud<PointT>, Eigen::aligned_allocator<PointCloud<PointT> > > pcl::PointCloud< PointT >::CloudVectorType

Definition at line 427 of file point_cloud.h.

template<typename PointT>

typedef VectorType::const_iterator pcl::PointCloud< PointT >::const_iterator

Definition at line 433 of file point_cloud.h.

template<typename PointT>

typedef boost::shared_ptr<const PointCloud<PointT> > pcl::PointCloud< PointT >::ConstPtr

Definition at line 429 of file point_cloud.h.

template<typename PointT>

typedef VectorType::iterator pcl::PointCloud< PointT >::iterator

Definition at line 432 of file point_cloud.h.

template<typename PointT>

typedef PointT pcl::PointCloud< PointT >::PointType

Definition at line 425 of file point_cloud.h.

template<typename PointT>

typedef boost::shared_ptr<PointCloud<PointT> > pcl::PointCloud< PointT >::Ptr

Definition at line 428 of file point_cloud.h.

template<typename PointT>

typedef std::vector<PointT, Eigen::aligned_allocator<PointT> > pcl::PointCloud< PointT >::VectorType

Definition at line 426 of file point_cloud.h.

## Constructor & Destructor Documentation

template<typename PointT>

pcl::PointCloud< PointT >::PointCloud | ( |  | ) |

inline

Default constructor.

Sets is_dense to true, width and height to 0, and the sensor_origin_ and sensor_orientation_ to identity.

Definition at line 179 of file point_cloud.h.

template<typename PointT>

pcl::PointCloud< PointT >::PointCloud | ( | PointCloud< PointT > & | pc | ) |

inline

Copy constructor (needed by compilers such as Intel C++)

Parameters

  [in] | pc | the cloud to copy into this

Definition at line 188 of file point_cloud.h.

template<typename PointT>

pcl::PointCloud< PointT >::PointCloud | ( | const PointCloud< PointT > & | pc | ) |

inline

Copy constructor (needed by compilers such as Intel C++)

Parameters

  [in] | pc | the cloud to copy into this

Definition at line 199 of file point_cloud.h.

template<typename PointT>

pcl::PointCloud< PointT >::PointCloud | ( | const PointCloud< PointT > & | pc,
|  | const std::vector< int > & | indices
| ) |  |

inline

Copy constructor from point cloud subset.

Parameters

  [in] | pc | the cloud to copy into this
  [in] | indices | the subset to copy

Definition at line 211 of file point_cloud.h.

template<typename PointT>

pcl::PointCloud< PointT >::PointCloud | ( | uint32_t | width_,
|  | uint32_t | height_,
|  | const PointT & | value_ = `PointT ()`
| ) |  |

inline

Allocate constructor from point cloud subset.

Parameters

  [in] | width_ | the cloud width
  [in] | height_ | the cloud height
  [in] | value_ | default value

Definition at line 228 of file point_cloud.h.

template<typename PointT>

virtual pcl::PointCloud< PointT >::~PointCloud | ( |  | ) |

inline virtual

Destructor.

Definition at line 240 of file point_cloud.h.

## Member Function Documentation

template<typename PointT>

const PointT& pcl::PointCloud< PointT >::at | ( | int | column,
|  | int | row
| ) |  | const

inline

Obtain the point given by the (column, row) coordinates.

Only works on organized datasets (those that have height != 1).

Parameters

  [in] | column | the column coordinate
  [in] | row | the row coordinate

Definition at line 283 of file point_cloud.h.

Referenced by pcl::FastBilateralFilterOMP< PointT >::applyFilter(), pcl::FrustumCulling< PointT >::applyFilter(), pcl::filters::Pyramid< PointT >::compute(), pcl::occlusion_reasoning::filter(), pcl::occlusion_reasoning::getOccludedCloud(), and pcl::PointCloudDepthAndRGBtoXYZRGBA().

template<typename PointT>

PointT& pcl::PointCloud< PointT >::at | ( | int | column,
|  | int | row
| ) |  |

inline

Obtain the point given by the (column, row) coordinates.

Only works on organized datasets (those that have height != 1).

Parameters

  [in] | column | the column coordinate
  [in] | row | the row coordinate

Definition at line 297 of file point_cloud.h.

template<typename PointT>

const PointT& pcl::PointCloud< PointT >::at | ( | size_t | n | ) | const

inline

Definition at line 460 of file point_cloud.h.

template<typename PointT>

PointT& pcl::PointCloud< PointT >::at | ( | size_t | n | ) |

inline

Definition at line 461 of file point_cloud.h.

template<typename PointT>

const PointT& pcl::PointCloud< PointT >::back | ( |  | ) | const

inline

Definition at line 464 of file point_cloud.h.

Referenced by pcl::VoxelGridCovariance< PointT >::applyFilter().

template<typename PointT>

PointT& pcl::PointCloud< PointT >::back | ( |  | ) |

inline

Definition at line 465 of file point_cloud.h.

template<typename PointT>

iterator pcl::PointCloud< PointT >::begin | ( |  | ) |

inline

Definition at line 434 of file point_cloud.h.

Referenced by pcl::GeneralizedIterativeClosestPoint< PointSource, PointTarget >::computeCovariances(), pcl::common::deleteCols(), pcl::common::deleteRows(), pcl::RangeImage::doZBuffer(), pcl::common::duplicateColumns(), pcl::common::duplicateRows(), pcl::common::expandColumns(), pcl::common::expandRows(), pcl::ism::ImplicitShapeModelEstimation< FeatureSize, PointT, NormalT >::extractDescriptors(), pcl::common::CloudGenerator< PointT, GeneratorT >::fill(), pcl::common::CloudGenerator< pcl::PointXY, GeneratorT >::fill(), pcl::SupervoxelClustering< PointT >::getColoredCloud(), pcl::SupervoxelClustering< PointT >::getColoredVoxelCloud(), pcl::SupervoxelClustering< PointT >::getLabeledCloud(), pcl::SupervoxelClustering< PointT >::getLabeledVoxelCloud(), pcl::SupervoxelClustering< PointT >::VoxelData::getNormal(), pcl::SupervoxelClustering< PointT >::makeSupervoxelNormalCloud(), pcl::common::mirrorColumns(), pcl::common::mirrorRows(), pcl::MovingLeastSquares< PointInT, PointOutT >::performProcessing(), and pcl::HarrisKeypoint6D< PointInT, PointOutT, NormalT >::refineCorners().

template<typename PointT>

const_iterator pcl::PointCloud< PointT >::begin | ( |  | ) | const

inline

Definition at line 436 of file point_cloud.h.

template<typename PointT>

void pcl::PointCloud< PointT >::clear | ( |  | ) |

inline

Removes all points in a cloud and sets the width and height to 0.

Definition at line 567 of file point_cloud.h.

Referenced by pcl::VoxelGridCovariance< PointT >::applyFilter(), pcl::approximatePolygon2D(), pcl::GFPFHEstimation< PointInT, PointLT, PointOutT >::computeFeature(), pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::computeRFAndShapeDistribution(), pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::detectKeypoints(), pcl::TrajkovicKeypoint2D< PointInT, PointOutT, IntensityT >::detectKeypoints(), pcl::TrajkovicKeypoint3D< PointInT, PointOutT, NormalT >::detectKeypoints(), pcl::VoxelGridCovariance< PointT >::getDisplayCloud(), pcl::SupervoxelClustering< PointT >::VoxelData::getNormal(), pcl::MarchingCubes< PointNT >::performReconstruction(), pcl::SurfaceReconstruction< PointInT >::reconstruct(), pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::responseHarris(), pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::responseLowe(), pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::responseNoble(), and pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::responseTomasi().

template<typename PointT>

bool pcl::PointCloud< PointT >::empty | ( |  | ) | const

inline

Definition at line 442 of file point_cloud.h.

Referenced by pcl::compute3DCentroid(), pcl::computeNDCentroid(), pcl::common::CloudGenerator< PointT, GeneratorT >::fill(), pcl::common::CloudGenerator< pcl::PointXY, GeneratorT >::fill(), pcl::PCDWriter::writeASCII(), and pcl::PCDWriter::writeBinary().

template<typename PointT>

iterator pcl::PointCloud< PointT >::end | ( |  | ) |

inline

Definition at line 435 of file point_cloud.h.

Referenced by pcl::GeneralizedIterativeClosestPoint< PointSource, PointTarget >::computeCovariances(), pcl::common::deleteRows(), pcl::RangeImage::doZBuffer(), pcl::common::duplicateRows(), pcl::common::expandRows(), pcl::common::CloudGenerator< PointT, GeneratorT >::fill(), pcl::common::CloudGenerator< pcl::PointXY, GeneratorT >::fill(), pcl::SupervoxelClustering< PointT >::getColoredCloud(), pcl::SupervoxelClustering< PointT >::getColoredVoxelCloud(), pcl::SupervoxelClustering< PointT >::getLabeledCloud(), pcl::SupervoxelClustering< PointT >::getLabeledVoxelCloud(), pcl::common::mirrorRows(), pcl::MovingLeastSquares< PointInT, PointOutT >::performProcessing(), and pcl::HarrisKeypoint6D< PointInT, PointOutT, NormalT >::refineCorners().

template<typename PointT>

const_iterator pcl::PointCloud< PointT >::end | ( |  | ) | const

inline

Definition at line 437 of file point_cloud.h.

template<typename PointT>

iterator pcl::PointCloud< PointT >::erase | ( | iterator | position | ) |

inline

Erase a point in the cloud.

Note
  This breaks the organized structure of the cloud by setting the height to 1!

Parameters

  [in] | position | what data point to erase

Returns
  returns the new position iterator

Definition at line 528 of file point_cloud.h.

Referenced by pcl::common::deleteCols(), and pcl::common::deleteRows().

template<typename PointT>

iterator pcl::PointCloud< PointT >::erase | ( | iterator | first,
|  | iterator | last
| ) |  |

inline

Erase a set of points given by a (first, last) iterator pair.

Note
  This breaks the organized structure of the cloud by setting the height to 1!

Parameters

  [in] | first | where to start erasing points from
  [in] | last | where to stop erasing points from

Returns
  returns the new position iterator

Definition at line 543 of file point_cloud.h.

template<typename PointT>

const PointT& pcl::PointCloud< PointT >::front | ( |  | ) | const

inline

Definition at line 462 of file point_cloud.h.

Referenced by pcl::PPFRegistration< PointSource, PointTarget >::setInputTarget().

template<typename PointT>

PointT& pcl::PointCloud< PointT >::front | ( |  | ) |

inline

Definition at line 463 of file point_cloud.h.

template<typename PointT>

Eigen::Map<Eigen::MatrixXf, Eigen::Aligned, Eigen::OuterStride<> > pcl::PointCloud< PointT >::getMatrixXfMap | ( | int | dim,
|  | int | stride,
|  | int | offset
| ) |  |

inline

Return an Eigen MatrixXf (assumes float values) mapped to the specified dimensions of the PointCloud.

Note
  This method is for advanced users only! Use with care!

Attention
  Since 1.4.0, Eigen matrices are forced to Row Major to increase the efficiency of the algorithms in PCL This means that the behavior of getMatrixXfMap changed, and is now correctly mapping 1-1 with a PointCloud structure, that is: number of points in a cloud = rows in a matrix, number of point dimensions = columns in a matrix

Parameters

  [in] | dim | the number of dimensions to consider for each point
  [in] | stride | the number of values in each point (will be the number of values that separate two of the columns)
  [in] | offset | the number of dimensions to skip from the beginning of each point (stride = offset + dim + x, where x is the number of dimensions to skip from the end of each point)

Note
  for getting only XYZ coordinates out of PointXYZ use dim=3, stride=4 and offset=0 due to the alignment.

Attention
  PointT types are most of the time aligned, so the offsets are not continuous!

Definition at line 352 of file point_cloud.h.

template<typename PointT>

const Eigen::Map<const Eigen::MatrixXf, Eigen::Aligned, Eigen::OuterStride<> > pcl::PointCloud< PointT >::getMatrixXfMap | ( | int | dim,
|  | int | stride,
|  | int | offset
| ) |  | const

inline

Return an Eigen MatrixXf (assumes float values) mapped to the specified dimensions of the PointCloud.

Note
  This method is for advanced users only! Use with care!

Attention
  Since 1.4.0, Eigen matrices are forced to Row Major to increase the efficiency of the algorithms in PCL This means that the behavior of getMatrixXfMap changed, and is now correctly mapping 1-1 with a PointCloud structure, that is: number of points in a cloud = rows in a matrix, number of point dimensions = columns in a matrix

Parameters

  [in] | dim | the number of dimensions to consider for each point
  [in] | stride | the number of values in each point (will be the number of values that separate two of the columns)
  [in] | offset | the number of dimensions to skip from the beginning of each point (stride = offset + dim + x, where x is the number of dimensions to skip from the end of each point)

Note
  for getting only XYZ coordinates out of PointXYZ use dim=3, stride=4 and offset=0 due to the alignment.

Attention
  PointT types are most of the time aligned, so the offsets are not continuous!

Definition at line 376 of file point_cloud.h.

template<typename PointT>

Eigen::Map<Eigen::MatrixXf, Eigen::Aligned, Eigen::OuterStride<> > pcl::PointCloud< PointT >::getMatrixXfMap | ( |  | ) |

inline

Return an Eigen MatrixXf (assumes float values) mapped to the PointCloud.

Note
  This method is for advanced users only! Use with care!

Attention
  PointT types are most of the time aligned, so the offsets are not continuous! See getMatrixXfMap for more information.

Definition at line 390 of file point_cloud.h.

template<typename PointT>

const Eigen::Map<const Eigen::MatrixXf, Eigen::Aligned, Eigen::OuterStride<> > pcl::PointCloud< PointT >::getMatrixXfMap | ( |  | ) | const

inline

Return an Eigen MatrixXf (assumes float values) mapped to the PointCloud.

Note
  This method is for advanced users only! Use with care!

Attention
  PointT types are most of the time aligned, so the offsets are not continuous! See getMatrixXfMap for more information.

Definition at line 401 of file point_cloud.h.

template<typename PointT>

iterator pcl::PointCloud< PointT >::insert | ( | iterator | position,
|  | const PointT & | pt
| ) |  |

inline

Insert a new point in the cloud, given an iterator.

Note
  This breaks the organized structure of the cloud by setting the height to 1!

Parameters

  [in] | position | where to insert the point
  [in] | pt | the point to insert

Returns
  returns the new position iterator

Definition at line 486 of file point_cloud.h.

Referenced by pcl::common::duplicateColumns(), pcl::common::duplicateRows(), pcl::common::expandColumns(), pcl::common::expandRows(), pcl::common::mirrorColumns(), pcl::common::mirrorRows(), and pcl::MovingLeastSquares< PointInT, PointOutT >::performProcessing().

template<typename PointT>

void pcl::PointCloud< PointT >::insert | ( | iterator | position,
|  | size_t | n,
|  | const PointT & | pt
| ) |  |

inline

Insert a new point in the cloud N times, given an iterator.

Note
  This breaks the organized structure of the cloud by setting the height to 1!

Parameters

  [in] | position | where to insert the point
  [in] | n | the number of times to insert the point
  [in] | pt | the point to insert

Definition at line 501 of file point_cloud.h.

template<typename PointT>
template<class InputIterator >

void pcl::PointCloud< PointT >::insert | ( | iterator | position,
|  | InputIterator | first,
|  | InputIterator | last
| ) |  |

inline

Insert a new range of points in the cloud, at a certain position.

Note
  This breaks the organized structure of the cloud by setting the height to 1!

Parameters

  [in] | position | where to insert the data
  [in] | first | where to start inserting the points from
  [in] | last | where to stop inserting the points from

Definition at line 515 of file point_cloud.h.

template<typename PointT>

bool pcl::PointCloud< PointT >::isOrganized | ( |  | ) | const

inline

Return whether a dataset is organized (e.g., arranged in a structured grid).

Note
  The height value must be different than 1 for a dataset to be organized.

Definition at line 331 of file point_cloud.h.

Referenced by pcl::visualization::ImageViewer::addMask(), pcl::HypothesisVerification< ModelT, SceneT >::addModels(), pcl::visualization::ImageViewer::addPlanarPolygon(), pcl::visualization::PCLVisualizer::addPointCloudNormals(), pcl::visualization::ImageViewer::addRectangle(), pcl::common::deleteCols(), pcl::common::duplicateColumns(), pcl::common::expandColumns(), pcl::io::PointCloudImageExtractor< PointT >::extract(), pcl::common::mirrorColumns(), and pcl::PCDGrabber< PointT >::publish().

template<typename PointT>

Ptr pcl::PointCloud< PointT >::makeShared | ( |  | ) | const

inline

Copy the cloud to the heap and return a smart pointer Note that deep copy is performed, so avoid using this function on non-empty clouds.

The changes of the returned cloud are not mirrored back to this one.

Returns
  shared pointer to the copy of the cloud

Definition at line 580 of file point_cloud.h.

Referenced by pcl::ism::ImplicitShapeModelEstimation< FeatureSize, PointT, NormalT >::estimateFeatures(), and pcl::PCA< PointT >::PCA().

template<typename PointT>

const PointT& pcl::PointCloud< PointT >::operator() | ( | size_t | column,
|  | size_t | row
| ) |  | const

inline

Obtain the point given by the (column, row) coordinates.

Only works on organized datasets (those that have height != 1).

Parameters

  [in] | column | the column coordinate
  [in] | row | the row coordinate

Definition at line 311 of file point_cloud.h.

template<typename PointT>

PointT& pcl::PointCloud< PointT >::operator() | ( | size_t | column,
|  | size_t | row
| ) |  |

inline

Obtain the point given by the (column, row) coordinates.

Only works on organized datasets (those that have height != 1).

Parameters

  [in] | column | the column coordinate
  [in] | row | the row coordinate

Definition at line 322 of file point_cloud.h.

template<typename PointT>

const PointCloud pcl::PointCloud< PointT >::operator+ | ( | const PointCloud< PointT > & | rhs | ) |

inline

Add a point cloud to another cloud.

Parameters

  [in] | rhs | the cloud to add to the current cloud

Returns
  the new cloud as a concatenation of the current cloud and the new given cloud

Definition at line 272 of file point_cloud.h.

template<typename PointT>

PointCloud& pcl::PointCloud< PointT >::operator+= | ( | const PointCloud< PointT > & | rhs | ) |

inline

Add a point cloud to the current cloud.

Parameters

  [in] | rhs | the cloud to add to the current cloud

Returns
  the new cloud as a concatenation of the current cloud and the new given cloud

Definition at line 247 of file point_cloud.h.

template<typename PointT>

const PointT& pcl::PointCloud< PointT >::operator[] | ( | size_t | n | ) | const

inline

Definition at line 458 of file point_cloud.h.

template<typename PointT>

PointT& pcl::PointCloud< PointT >::operator[] | ( | size_t | n | ) |

inline

Definition at line 459 of file point_cloud.h.

template<typename PointT>

void pcl::PointCloud< PointT >::push_back | ( | const PointT & | pt | ) |

inline

Insert a new point in the cloud, at the end of the container.

Note
  This breaks the organized structure of the cloud by setting the height to 1!

Parameters

  [in] | pt | the point to insert

Definition at line 472 of file point_cloud.h.

Referenced by pcl::geometry::MeshBase< QuadMesh< MeshTraitsT >, MeshTraitsT, QuadMeshTag >::addData(), pcl::CropHull< PointT >::applyFilter(), pcl::VoxelGridCovariance< PointT >::applyFilter(), pcl::approximatePolygon2D(), pcl::MovingLeastSquares< PointInT, PointOutT >::computeMLSPointNormal(), pcl::MarchingCubes< PointNT >::createSurface(), pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::detectKeypoints(), pcl::TrajkovicKeypoint2D< PointInT, PointOutT, IntensityT >::detectKeypoints(), pcl::TrajkovicKeypoint3D< PointInT, PointOutT, NormalT >::detectKeypoints(), pcl::VoxelGridCovariance< PointT >::getDisplayCloud(), pcl::MovingLeastSquares< PointInT, PointOutT >::performUpsampling(), pcl::PCA< PointT >::project(), pcl::PCA< PointT >::reconstruct(), pcl::OrganizedConnectedComponentSegmentation< PointT, PointLT >::segment(), pcl::tracking::PyramidalKLTTracker< PointInT, IntensityT >::setPointsToTrack(), and pcl::tracking::PyramidalKLTTracker< PointInT, IntensityT >::track().

template<typename PointT>

void pcl::PointCloud< PointT >::reserve | ( | size_t | n | ) |

inline

Definition at line 441 of file point_cloud.h.

Referenced by pcl::approximatePolygon2D(), pcl::tracking::PyramidalKLTTracker< PointInT, IntensityT >::computeTracking(), pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::detectKeypoints(), pcl::TrajkovicKeypoint2D< PointInT, PointOutT, IntensityT >::detectKeypoints(), pcl::TrajkovicKeypoint3D< PointInT, PointOutT, NormalT >::detectKeypoints(), pcl::common::duplicateColumns(), pcl::common::duplicateRows(), pcl::common::expandColumns(), pcl::common::expandRows(), pcl::common::mirrorColumns(), pcl::common::mirrorRows(), and pcl::tracking::PyramidalKLTTracker< PointInT, IntensityT >::setPointsToTrack().

template<typename PointT>

void pcl::PointCloud< PointT >::resize | ( | size_t | n | ) |

inline

Resize the cloud.

Parameters

  [in] | n | the new cloud size

Definition at line 447 of file point_cloud.h.

Referenced by pcl::CovarianceSampling< PointT, PointNT >::applyFilter(), pcl::SurfaceNormalModality< PointInT >::computeAndQuantizeSurfaceNormals(), pcl::LineRGBD< PointXYZT, PointRGBT >::computeTransformedTemplatePoints(), pcl::filters::Convolution3D< PointIn, PointOut, KernelT >::convolve(), pcl::copyPointCloud(), pcl::demeanPointCloud(), pcl::HarrisKeypoint6D< PointInT, PointOutT, NormalT >::detectKeypoints(), pcl::common::CloudGenerator< PointT, GeneratorT >::fill(), pcl::common::CloudGenerator< pcl::PointXY, GeneratorT >::fill(), pcl::SupervoxelClustering< PointT >::VoxelData::getNormal(), pcl::filters::Convolution< PointIn, PointOut >::initCompute(), pcl::SupervoxelClustering< PointT >::makeSupervoxelNormalCloud(), pcl::search::Search< PointXYZRGB >::nearestKSearchT(), pcl::BilateralUpsampling< PointInT, PointOutT >::performProcessing(), pcl::Poisson< PointNT >::performReconstruction(), pcl::GridProjection< PointNT >::performReconstruction(), pcl::PPFRGBRegionEstimation< PointInT, PointNT, PointOutT >::PPFRGBRegionEstimation(), pcl::ColorGradientModality< PointInT >::processInputData(), pcl::PCA< PointT >::project(), pcl::search::Search< PointXYZRGB >::radiusSearchT(), pcl::io::LZFDepth16ImageReader::read(), pcl::io::LZFRGB24ImageReader::read(), pcl::io::LZFYUV422ImageReader::read(), pcl::io::LZFBayer8ImageReader::read(), pcl::io::LZFDepth16ImageReader::readOMP(), pcl::io::LZFRGB24ImageReader::readOMP(), pcl::io::LZFYUV422ImageReader::readOMP(), pcl::io::LZFBayer8ImageReader::readOMP(), pcl::PCA< PointT >::reconstruct(), pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::responseHarris(), pcl::HarrisKeypoint3D< PointInT, PointOutT, NormalT >::responseHarris(), pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::responseLowe(), pcl::HarrisKeypoint3D< PointInT, PointOutT, NormalT >::responseLowe(), pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::responseNoble(), pcl::HarrisKeypoint3D< PointInT, PointOutT, NormalT >::responseNoble(), pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::responseTomasi(), pcl::HarrisKeypoint3D< PointInT, PointOutT, NormalT >::responseTomasi(), pcl::OrganizedMultiPlaneSegmentation< PointT, PointNT, PointLT >::segment(), pcl::OrganizedMultiPlaneSegmentation< PointT, PointNT, PointLT >::segmentAndRefine(), pcl::tracking::PyramidalKLTTracker< PointInT, IntensityT >::setPointsToTrack(), and pcl::registration::TransformationValidationEuclidean< PointSource, PointTarget, Scalar >::validateTransformation().

template<typename PointT>

size_t pcl::PointCloud< PointT >::size | ( |  | ) | const

inline

Definition at line 440 of file point_cloud.h.

Referenced by pcl::visualization::ImageViewer::addMask(), pcl::visualization::ImageViewer::addPlanarPolygon(), pcl::visualization::PCLVisualizer::addPolygonMesh(), pcl::LineRGBD< PointXYZT, PointRGBT >::addTemplate(), pcl::recognition::TrimmedICP< pcl::pcl::PointXYZ, float >::align(), pcl::FastBilateralFilterOMP< PointT >::applyFilter(), pcl::CovarianceSampling< PointT, PointNT >::applyFilter(), pcl::approximatePolygon(), pcl::approximatePolygon2D(), pcl::calculatePolygonArea(), pcl::PlaneClipper3D< PointT >::clipPointCloud3D(), pcl::BoxClipper3D< PointT >::clipPointCloud3D(), pcl::compute3DCentroid(), pcl::computeCentroid(), pcl::computeCovarianceMatrix(), pcl::GeneralizedIterativeClosestPoint< PointSource, PointTarget >::computeCovariances(), pcl::GFPFHEstimation< PointInT, PointLT, PointOutT >::computeFeature(), pcl::computeMeanAndCovarianceMatrix(), pcl::computeNDCentroid(), pcl::computePointNormal(), pcl::LineRGBD< PointXYZT, PointRGBT >::computeTransformedTemplatePoints(), pcl::copyPointCloud(), pcl::LineRGBD< PointXYZT, PointRGBT >::createAndAddTemplate(), pcl::demeanPointCloud(), pcl::tracking::PyramidalKLTTracker< PointInT, IntensityT >::derivatives(), pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::detectKeypoints(), pcl::SIFTKeypoint< PointInT, PointOutT >::detectKeypoints(), pcl::TrajkovicKeypoint2D< PointInT, PointOutT, IntensityT >::detectKeypoints(), pcl::TrajkovicKeypoint3D< PointInT, PointOutT, NormalT >::detectKeypoints(), pcl::registration::TransformationEstimationPointToPlaneWeighted< PointSource, PointTarget, MatScalar >::estimateRigidTransformation(), pcl::ism::ImplicitShapeModelEstimation< FeatureSize, PointT, NormalT >::extractDescriptors(), pcl::ism::ImplicitShapeModelEstimation< FeatureSize, PointT, NormalT >::findObjects(), pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT >::getBoundaryPoints(), pcl::LineRGBD< PointXYZT, PointRGBT >::loadTemplates(), pcl::search::Search< PointT >::nearestKSearch(), pcl::search::FlannSearch< PointT, FlannDistance >::nearestKSearch(), pcl::search::Search< PointXYZRGB >::nearestKSearchT(), pcl::MovingLeastSquares< PointInT, PointOutT >::performProcessing(), pcl::ConcaveHull< PointInT >::performReconstruction(), pcl::GridProjection< PointNT >::performReconstruction(), pcl::MarchingCubes< PointNT >::performReconstruction(), pcl::PointCloud< ModelT >::PointCloud(), pcl::io::pointCloudTovtkPolyData(), pcl::PPFRGBRegionEstimation< PointInT, PointNT, PointOutT >::PPFRGBRegionEstimation(), pcl::MovingLeastSquares< PointInT, PointOutT >::process(), pcl::PCA< PointT >::project(), pcl::search::FlannSearch< PointT, FlannDistance >::radiusSearch(), pcl::search::Search< PointT >::radiusSearch(), pcl::search::Search< PointXYZRGB >::radiusSearchT(), pcl::io::LZFRGB24ImageReader::read(), pcl::io::LZFBayer8ImageReader::read(), pcl::io::LZFDepth16ImageReader::readOMP(), pcl::io::LZFRGB24ImageReader::readOMP(), pcl::io::LZFBayer8ImageReader::readOMP(), pcl::PCA< PointT >::reconstruct(), pcl::HarrisKeypoint3D< PointInT, PointOutT, NormalT >::refineCorners(), pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::responseHarris(), pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::responseLowe(), pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::responseNoble(), pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::responseTomasi(), pcl::geometry::MeshBase< QuadMesh< MeshTraitsT >, MeshTraitsT, QuadMeshTag >::setEdgeDataCloud(), pcl::geometry::MeshBase< QuadMesh< MeshTraitsT >, MeshTraitsT, QuadMeshTag >::setFaceDataCloud(), pcl::geometry::MeshBase< QuadMesh< MeshTraitsT >, MeshTraitsT, QuadMeshTag >::setHalfEdgeDataCloud(), pcl::SupervoxelClustering< PointT >::setInputCloud(), pcl::GeneralizedIterativeClosestPoint< PointSource, PointTarget >::setInputSource(), pcl::tracking::PyramidalKLTTracker< PointInT, IntensityT >::setPointsToTrack(), pcl::geometry::MeshBase< QuadMesh< MeshTraitsT >, MeshTraitsT, QuadMeshTag >::setVertexDataCloud(), pcl::tracking::PyramidalKLTTracker< PointInT, IntensityT >::track(), pcl::IterativeClosestPoint< PointSource, PointTarget, Scalar >::transformCloud(), and pcl::visualization::PCLVisualizer::updatePolygonMesh().

template<typename PointT>

void pcl::PointCloud< PointT >::swap | ( | PointCloud< PointT > & | rhs | ) |

inline

Swap a point cloud with another cloud.

Parameters

  [in,out] | rhs | point cloud to swap this with

Definition at line 555 of file point_cloud.h.

## Friends And Related Function Documentation

template<typename PointT>

boost::shared_ptr<MsgFieldMap>& detail::getMapping | ( | pcl::PointCloud< PointT > & | p | ) |

friend

## Member Data Documentation

template<typename PointT>

pcl::PCLHeader pcl::PointCloud< PointT >::header

The point cloud header.

It contains information about the acquisition time.

Definition at line 407 of file point_cloud.h.

Referenced by pcl::Registration< PointSource, PointTarget, Scalar >::align(), pcl::CovarianceSampling< PointT, PointNT >::applyFilter(), pcl::ConditionalRemoval< PointT >::applyFilter(), pcl::ESFEstimation< PointInT, PointOutT >::compute(), pcl::GFPFHEstimation< PointInT, PointLT, PointOutT >::compute(), pcl::VFHEstimation< PointInT, PointNT, PointOutT >::compute(), pcl::CVFHEstimation< PointInT, PointNT, PointOutT >::compute(), pcl::Feature< PointInT, PointOutT >::compute(), pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::compute(), pcl::concatenateFields(), pcl::copyPointCloud(), pcl::demeanPointCloud(), pcl::SmoothedSurfacesKeypoint< PointT, PointNT >::detectKeypoints(), pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT >::detectKeypoints(), pcl::MultiscaleFeaturePersistence< PointSource, PointFeature >::determinePersistentFeatures(), pcl::extractEuclideanClusters(), pcl::extractLabeledEuclideanClusters(), pcl::Filter< pcl::PointXYZRGBL >::filter(), pcl::fromPCLPointCloud2(), pcl::MomentOfInertiaEstimation< PointT >::getEccentricity(), pcl::getPointCloudDifference(), pcl::PointCloud< ModelT >::operator+=(), pcl::operator<<(), pcl::BilateralUpsampling< PointInT, PointOutT >::performProcessing(), pcl::GridProjection< PointNT >::performReconstruction(), pcl::CloudSurfaceProcessing< PointInT, PointOutT >::process(), pcl::BilateralUpsampling< PointInT, PointOutT >::process(), pcl::MovingLeastSquares< PointInT, PointOutT >::process(), pcl::SampleConsensusModelLine< PointT >::projectPoints(), pcl::SampleConsensusModelStick< PointT >::projectPoints(), pcl::SampleConsensusModelCircle3D< PointT >::projectPoints(), pcl::SampleConsensusModelCircle2D< PointT >::projectPoints(), pcl::SampleConsensusModelSphere< PointT >::projectPoints(), pcl::SampleConsensusModelCylinder< PointT, PointNT >::projectPoints(), pcl::SampleConsensusModelPlane< PointT >::projectPoints(), pcl::SampleConsensusModelCone< PointT, PointNT >::projectPoints(), pcl::ConcaveHull< PointInT >::reconstruct(), pcl::ConvexHull< PointInT >::reconstruct(), pcl::SurfaceReconstruction< PointInT >::reconstruct(), pcl::removeNaNFromPointCloud(), pcl::removeNaNNormalsFromPointCloud(), pcl::SegmentDifferences< PointT >::segment(), pcl::toPCLPointCloud2(), pcl::transformPointCloud(), and pcl::transformPointCloudWithNormals().

template<typename PointT>

uint32_t pcl::PointCloud< PointT >::height

The point cloud height (if organized as an image-structure).

Definition at line 415 of file point_cloud.h.

Referenced by pcl::visualization::ImageViewer::addMask(), pcl::visualization::ImageViewer::addPlanarPolygon(), pcl::visualization::PCLVisualizer::addPointCloudNormals(), pcl::visualization::ImageViewer::addRectangle(), pcl::visualization::ImageViewer::addRGBImage(), pcl::Registration< PointSource, PointTarget, Scalar >::align(), pcl::FastBilateralFilterOMP< PointT >::applyFilter(), pcl::LocalMaximum< PointT >::applyFilter(), pcl::MedianFilter< PointT >::applyFilter(), pcl::FastBilateralFilter< PointT >::applyFilter(), pcl::GridMinimum< PointT >::applyFilter(), pcl::ShadowPoints< PointT, NormalT >::applyFilter(), pcl::SamplingSurfaceNormal< PointT >::applyFilter(), pcl::CovarianceSampling< PointT, PointNT >::applyFilter(), pcl::ProjectInliers< PointT >::applyFilter(), pcl::ApproximateVoxelGrid< PointT >::applyFilter(), pcl::VoxelGrid< PointT >::applyFilter(), pcl::VoxelGridCovariance< PointT >::applyFilter(), pcl::ConditionalRemoval< PointT >::applyFilter(), pcl::LineRGBD< PointXYZT, PointRGBT >::applyProjectiveDepthICPOnDetections(), pcl::ESFEstimation< PointInT, PointOutT >::compute(), pcl::GFPFHEstimation< PointInT, PointLT, PointOutT >::compute(), pcl::filters::Pyramid< PointT >::compute(), pcl::VFHEstimation< PointInT, PointNT, PointOutT >::compute(), pcl::CVFHEstimation< PointInT, PointNT, PointOutT >::compute(), pcl::Feature< PointInT, PointOutT >::compute(), pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::compute(), pcl::SurfaceNormalModality< PointInT >::computeAndQuantizeSurfaceNormals(), pcl::ESFEstimation< PointInT, PointOutT >::computeFeature(), pcl::GFPFHEstimation< PointInT, PointLT, PointOutT >::computeFeature(), pcl::IntensitySpinEstimation< PointInT, PointOutT >::computeFeature(), pcl::RIFTEstimation< PointInT, GradientT, PointOutT >::computeFeature(), pcl::RSDEstimation< PointInT, PointNT, PointOutT >::computeFeature(), pcl::ColorGradientModality< PointInT >::computeMaxColorGradients(), pcl::ColorGradientModality< PointInT >::computeMaxColorGradientsSobel(), pcl::VFHEstimation< PointInT, PointNT, PointOutT >::computePointSPFHSignature(), pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::computeRFAndShapeDistribution(), pcl::LineRGBD< PointXYZT, PointRGBT >::computeTransformedTemplatePoints(), pcl::concatenateFields(), pcl::io::OrganizedConversion< PointT, false >::convert(), pcl::io::OrganizedConversion< PointT, true >::convert(), pcl::GaussianKernel::convolve(), pcl::filters::Convolution3D< PointIn, PointOut, KernelT >::convolve(), pcl::GaussianKernel::convolveCols(), pcl::GaussianKernel::convolveRows(), pcl::copyPointCloud(), pcl::CPPFEstimation< PointInT, PointNT, PointOutT >::CPPFEstimation(), pcl::common::deleteCols(), pcl::common::deleteRows(), pcl::demeanPointCloud(), pcl::tracking::PyramidalKLTTracker< PointInT, IntensityT >::derivatives(), pcl::SmoothedSurfacesKeypoint< PointT, PointNT >::detectKeypoints(), pcl::HarrisKeypoint6D< PointInT, PointOutT, NormalT >::detectKeypoints(), pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::detectKeypoints(), pcl::TrajkovicKeypoint2D< PointInT, PointOutT, IntensityT >::detectKeypoints(), pcl::TrajkovicKeypoint3D< PointInT, PointOutT, NormalT >::detectKeypoints(), pcl::HarrisKeypoint3D< PointInT, PointOutT, NormalT >::detectKeypoints(), pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT >::detectKeypoints(), pcl::MultiscaleFeaturePersistence< PointSource, PointFeature >::determinePersistentFeatures(), pcl::tracking::PyramidalKLTTracker< PointInT, IntensityT >::downsample(), pcl::common::duplicateColumns(), pcl::common::duplicateRows(), pcl::estimateProjectionMatrix(), pcl::common::expandColumns(), pcl::common::expandRows(), pcl::io::PointCloudImageExtractor< PointT >::extract(), pcl::io::PointCloudImageExtractorWithScaling< PointT >::extractImpl(), pcl::io::PointCloudImageExtractorFromNormalField< PointT >::extractImpl(), pcl::io::PointCloudImageExtractorFromRGBField< PointT >::extractImpl(), pcl::io::PointCloudImageExtractorFromLabelField< PointT >::extractImpl(), pcl::people::GroundBasedPeopleDetectionApp< PointT >::extractRGBFromPointCloud(), pcl::common::CloudGenerator< PointT, GeneratorT >::fill(), pcl::common::CloudGenerator< pcl::PointXY, GeneratorT >::fill(), pcl::occlusion_reasoning::filter(), pcl::CVFHEstimation< PointInT, PointNT, PointOutT >::filterNormalsWithHighCurvature(), pcl::fromPCLPointCloud2(), pcl::PCDWriter::generateHeader(), pcl::features::ISMVoteList< PointT >::getColoredCloud(), pcl::RegionGrowing< PointT, NormalT >::getColoredCloud(), pcl::RegionGrowing< PointT, NormalT >::getColoredCloudRGBA(), pcl::MomentOfInertiaEstimation< PointT >::getEccentricity(), pcl::occlusion_reasoning::getOccludedCloud(), pcl::getPointCloudDifference(), pcl::filters::Convolution< PointIn, PointOut >::initCompute(), pcl::outofcore::OutofcoreOctreeDiskContainer< PointT >::insertRange(), pcl::common::mirrorColumns(), pcl::common::mirrorRows(), pcl::operator<<(), pcl::BilateralUpsampling< PointInT, PointOutT >::performProcessing(), pcl::ConcaveHull< PointInT >::performReconstruction(), pcl::GridProjection< PointNT >::performReconstruction(), pcl::MarchingCubes< PointNT >::performReconstruction(), pcl::ConvexHull< PointInT >::performReconstruction2D(), pcl::ConvexHull< PointInT >::performReconstruction3D(), pcl::PointCloudDepthAndRGBtoXYZRGBA(), pcl::PointCloudRGBtoI(), pcl::io::pointCloudTovtkStructuredGrid(), pcl::PointCloudXYZRGBAtoXYZHSV(), pcl::PointCloudXYZRGBtoXYZHSV(), pcl::PointCloudXYZRGBtoXYZI(), pcl::PPFEstimation< PointInT, PointNT, PointOutT >::PPFEstimation(), pcl::PPFRGBEstimation< PointInT, PointNT, PointOutT >::PPFRGBEstimation(), pcl::CloudSurfaceProcessing< PointInT, PointOutT >::process(), pcl::BilateralUpsampling< PointInT, PointOutT >::process(), pcl::MovingLeastSquares< PointInT, PointOutT >::process(), pcl::ColorGradientModality< PointInT >::processInputData(), pcl::SampleConsensusModelLine< PointT >::projectPoints(), pcl::SampleConsensusModelStick< PointT >::projectPoints(), pcl::SampleConsensusModelCircle2D< PointT >::projectPoints(), pcl::SampleConsensusModelCircle3D< PointT >::projectPoints(), pcl::SampleConsensusModelSphere< PointT >::projectPoints(), pcl::SampleConsensusModelCylinder< PointT, PointNT >::projectPoints(), pcl::SampleConsensusModelPlane< PointT >::projectPoints(), pcl::SampleConsensusModelCone< PointT, PointNT >::projectPoints(), pcl::PCDGrabber< PointT >::publish(), pcl::outofcore::OutofcoreOctreeBaseNode< ContainerT, PointT >::queryBBIncludes(), pcl::io::LZFDepth16ImageReader::read(), pcl::io::LZFRGB24ImageReader::read(), pcl::io::LZFYUV422ImageReader::read(), pcl::io::LZFBayer8ImageReader::read(), pcl::io::LZFDepth16ImageReader::readOMP(), pcl::io::LZFRGB24ImageReader::readOMP(), pcl::io::LZFYUV422ImageReader::readOMP(), pcl::io::LZFBayer8ImageReader::readOMP(), pcl::ConcaveHull< PointInT >::reconstruct(), pcl::ConvexHull< PointInT >::reconstruct(), pcl::SurfaceReconstruction< PointInT >::reconstruct(), pcl::removeNaNFromPointCloud(), pcl::removeNaNNormalsFromPointCloud(), pcl::HarrisKeypoint3D< PointInT, PointOutT, NormalT >::responseCurvature(), pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::responseHarris(), pcl::HarrisKeypoint3D< PointInT, PointOutT, NormalT >::responseHarris(), pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::responseLowe(), pcl::HarrisKeypoint3D< PointInT, PointOutT, NormalT >::responseLowe(), pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::responseNoble(), pcl::HarrisKeypoint3D< PointInT, PointOutT, NormalT >::responseNoble(), pcl::HarrisKeypoint6D< PointInT, PointOutT, NormalT >::responseTomasi(), pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::responseTomasi(), pcl::HarrisKeypoint3D< PointInT, PointOutT, NormalT >::responseTomasi(), pcl::OrganizedConnectedComponentSegmentation< PointT, PointLT >::segment(), pcl::SegmentDifferences< PointT >::segment(), pcl::visualization::ImageViewer::showCorrespondences(), pcl::PointCloud< ModelT >::swap(), pcl::people::GroundBasedPeopleDetectionApp< PointT >::swapDimensions(), pcl::toPCLPointCloud2(), pcl::tracking::PyramidalKLTTracker< PointInT, IntensityT >::track(), pcl::transformPointCloud(), pcl::transformPointCloudWithNormals(), pcl::io::vtkPolyDataToPointCloud(), pcl::io::vtkStructuredGridToPointCloud(), pcl::PCDWriter::writeASCII(), and pcl::outofcore::OutofcoreOctreeDiskContainer< PointT >::~OutofcoreOctreeDiskContainer().

template<typename PointT>

bool pcl::PointCloud< PointT >::is_dense

True if no points are invalid (e.g., have NaN or Inf values).

Definition at line 418 of file point_cloud.h.

Referenced by pcl::visualization::PCLVisualizer::addPointCloud(), pcl::visualization::PCLVisualizer::addPolygonMesh(), pcl::Registration< PointSource, PointTarget, Scalar >::align(), pcl::LocalMaximum< PointT >::applyFilter(), pcl::GridMinimum< PointT >::applyFilter(), pcl::ExtractIndices< PointT >::applyFilter(), pcl::RandomSample< PointT >::applyFilter(), pcl::CovarianceSampling< PointT, PointNT >::applyFilter(), pcl::RadiusOutlierRemoval< PointT >::applyFilter(), pcl::StatisticalOutlierRemoval< PointT >::applyFilter(), pcl::NormalSpaceSampling< PointT, NormalT >::applyFilter(), pcl::CropBox< PointT >::applyFilter(), pcl::PassThrough< PointT >::applyFilter(), pcl::ModelOutlierRemoval< PointT >::applyFilter(), pcl::FrustumCulling< PointT >::applyFilter(), pcl::ApproximateVoxelGrid< PointT >::applyFilter(), pcl::VoxelGrid< PointT >::applyFilter(), pcl::VoxelGridCovariance< PointT >::applyFilter(), pcl::ConditionalRemoval< PointT >::applyFilter(), pcl::ESFEstimation< PointInT, PointOutT >::compute(), pcl::GFPFHEstimation< PointInT, PointLT, PointOutT >::compute(), pcl::VFHEstimation< PointInT, PointNT, PointOutT >::compute(), pcl::Feature< PointInT, PointOutT >::compute(), pcl::compute3DCentroid(), pcl::SurfaceNormalModality< PointInT >::computeAndQuantizeSurfaceNormals(), pcl::computeCentroid(), pcl::computeCovarianceMatrix(), pcl::IntensityGradientEstimation< PointInT, PointNT, PointOutT, IntensitySelectorT >::computeFeature(), pcl::SHOTLocalReferenceFrameEstimation< PointInT, PointOutT >::computeFeature(), pcl::SHOTLocalReferenceFrameEstimationOMP< PointInT, PointOutT >::computeFeature(), pcl::MomentInvariantsEstimation< PointInT, PointOutT >::computeFeature(), pcl::PrincipalCurvaturesEstimation< PointInT, PointNT, PointOutT >::computeFeature(), pcl::SHOTEstimationOMP< PointInT, PointNT, PointOutT, PointRFT >::computeFeature(), pcl::IntensitySpinEstimation< PointInT, PointOutT >::computeFeature(), pcl::UniqueShapeContext< PointInT, PointOutT, PointRFT >::computeFeature(), pcl::BoundaryEstimation< PointInT, PointNT, PointOutT >::computeFeature(), pcl::ShapeContext3DEstimation< PointInT, PointNT, PointOutT >::computeFeature(), pcl::PFHEstimation< PointInT, PointNT, PointOutT >::computeFeature(), pcl::SHOTColorEstimationOMP< PointInT, PointNT, PointOutT, PointRFT >::computeFeature(), pcl::FPFHEstimation< PointInT, PointNT, PointOutT >::computeFeature(), pcl::BOARDLocalReferenceFrameEstimation< PointInT, PointNT, PointOutT >::computeFeature(), pcl::SHOTEstimation< PointInT, PointNT, PointOutT, PointRFT >::computeFeature(), pcl::NormalEstimation< PointInT, PointOutT >::computeFeature(), pcl::SHOTColorEstimation< PointInT, PointNT, PointOutT, PointRFT >::computeFeature(), pcl::IntegralImageNormalEstimation< PointInT, PointOutT >::computeFeatureFull(), pcl::IntegralImageNormalEstimation< PointInT, PointOutT >::computeFeaturePart(), pcl::computeMeanAndCovarianceMatrix(), pcl::concatenateFields(), pcl::io::OrganizedConversion< PointT, false >::convert(), pcl::io::OrganizedConversion< PointT, true >::convert(), pcl::filters::Convolution3D< PointIn, PointOut, KernelT >::convolve(), pcl::copyPointCloud(), pcl::CPPFEstimation< PointInT, PointNT, PointOutT >::CPPFEstimation(), pcl::demeanPointCloud(), pcl::HarrisKeypoint6D< PointInT, PointOutT, NormalT >::detectKeypoints(), pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::detectKeypoints(), pcl::TrajkovicKeypoint2D< PointInT, PointOutT, IntensityT >::detectKeypoints(), pcl::TrajkovicKeypoint3D< PointInT, PointOutT, NormalT >::detectKeypoints(), pcl::HarrisKeypoint3D< PointInT, PointOutT, NormalT >::detectKeypoints(), pcl::AgastKeypoint2D< PointInT, PointOutT >::detectKeypoints(), pcl::MultiscaleFeaturePersistence< PointSource, PointFeature >::determinePersistentFeatures(), pcl::common::CloudGenerator< PointT, GeneratorT >::fill(), pcl::common::CloudGenerator< pcl::PointXY, GeneratorT >::fill(), pcl::fromPCLPointCloud2(), pcl::RegionGrowing< PointT, NormalT >::getColoredCloud(), pcl::RegionGrowing< PointT, NormalT >::getColoredCloudRGBA(), pcl::getMaxDistance(), pcl::getMinMax3D(), pcl::getPointCloudDifference(), pcl::getPointsInBox(), pcl::filters::Convolution< PointIn, PointOut >::initCompute(), pcl::search::FlannSearch< PointT, FlannDistance >::nearestKSearch(), pcl::PointCloud< ModelT >::operator+=(), pcl::operator<<(), pcl::ConcaveHull< PointInT >::performReconstruction(), pcl::GridProjection< PointNT >::performReconstruction(), pcl::ConvexHull< PointInT >::performReconstruction2D(), pcl::ConvexHull< PointInT >::performReconstruction3D(), pcl::io::pointCloudTovtkPolyData(), pcl::PPFEstimation< PointInT, PointNT, PointOutT >::PPFEstimation(), pcl::ColorGradientModality< PointInT >::processInputData(), pcl::PCA< PointT >::project(), pcl::SampleConsensusModelLine< PointT >::projectPoints(), pcl::SampleConsensusModelStick< PointT >::projectPoints(), pcl::SampleConsensusModelCircle2D< PointT >::projectPoints(), pcl::SampleConsensusModelCircle3D< PointT >::projectPoints(), pcl::SampleConsensusModelSphere< PointT >::projectPoints(), pcl::SampleConsensusModelCylinder< PointT, PointNT >::projectPoints(), pcl::SampleConsensusModelPlane< PointT >::projectPoints(), pcl::SampleConsensusModelCone< PointT, PointNT >::projectPoints(), pcl::search::FlannSearch< PointT, FlannDistance >::radiusSearch(), pcl::io::LZFDepth16ImageReader::read(), pcl::io::LZFDepth16ImageReader::readOMP(), pcl::ConcaveHull< PointInT >::reconstruct(), pcl::ConvexHull< PointInT >::reconstruct(), pcl::PCA< PointT >::reconstruct(), pcl::removeNaNFromPointCloud(), pcl::PointCloud< ModelT >::swap(), pcl::toPCLPointCloud2(), pcl::transformPointCloud(), pcl::transformPointCloudWithNormals(), pcl::visualization::PCLVisualizer::updatePointCloud(), pcl::visualization::PCLVisualizer::updatePolygonMesh(), pcl::io::vtkPolyDataToPointCloud(), and pcl::io::vtkStructuredGridToPointCloud().

template<typename PointT>

boost::shared_ptr<MsgFieldMap> pcl::PointCloud< PointT >::mapping_

protected

Definition at line 584 of file point_cloud.h.

Referenced by pcl::detail::getMapping().

template<typename PointT>

std::vector<PointT, Eigen::aligned_allocator<PointT> > pcl::PointCloud< PointT >::points

The point data.

Definition at line 410 of file point_cloud.h.

Referenced by pcl::visualization::PCLVisualizer::addCorrespondences(), pcl::visualization::PCLHistogramVisualizer::addFeatureHistogram(), pcl::visualization::PCLPlotter::addFeatureHistogram(), pcl::visualization::PCLVisualizer::addPointCloud(), pcl::visualization::PCLVisualizer::addPointCloudIntensityGradients(), pcl::visualization::PCLVisualizer::addPointCloudNormals(), pcl::visualization::PCLVisualizer::addPolygonMesh(), pcl::visualization::ImageViewer::addRectangle(), pcl::LineRGBD< PointXYZT, PointRGBT >::addTemplate(), pcl::features::ISMVoteList< PointT >::addVote(), pcl::recognition::TrimmedICP< pcl::pcl::PointXYZ, float >::align(), pcl::Registration< PointSource, PointTarget, Scalar >::align(), pcl::BilateralFilter< PointT >::applyFilter(), pcl::LocalMaximum< PointT >::applyFilter(), pcl::GridMinimum< PointT >::applyFilter(), pcl::ShadowPoints< PointT, NormalT >::applyFilter(), pcl::ExtractIndices< PointT >::applyFilter(), pcl::SamplingSurfaceNormal< PointT >::applyFilter(), pcl::ProjectInliers< PointT >::applyFilter(), pcl::RadiusOutlierRemoval< PointT >::applyFilter(), pcl::StatisticalOutlierRemoval< PointT >::applyFilter(), pcl::NormalSpaceSampling< PointT, NormalT >::applyFilter(), pcl::CropBox< PointT >::applyFilter(), pcl::PassThrough< PointT >::applyFilter(), pcl::ModelOutlierRemoval< PointT >::applyFilter(), pcl::ApproximateVoxelGrid< PointT >::applyFilter(), pcl::VoxelGrid< PointT >::applyFilter(), pcl::VoxelGridCovariance< PointT >::applyFilter(), pcl::ConditionalRemoval< PointT >::applyFilter(), pcl::octree::OctreePointCloudSearch< PointT, LeafContainerT, BranchContainerT >::approxNearestSearch(), pcl::RangeImageBorderExtractor::calculateBorderDirection(), pcl::RangeImageBorderExtractor::calculateMainPrincipalCurvature(), pcl::ESFEstimation< PointInT, PointOutT >::cleanup9(), pcl::ESFEstimation< PointInT, PointOutT >::compute(), pcl::GFPFHEstimation< PointInT, PointLT, PointOutT >::compute(), pcl::VFHEstimation< PointInT, PointNT, PointOutT >::compute(), pcl::CVFHEstimation< PointInT, PointNT, PointOutT >::compute(), pcl::Feature< PointInT, PointOutT >::compute(), pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::compute(), pcl::SurfaceNormalModality< PointInT >::computeAndQuantizeSurfaceNormals(), pcl::occlusion_reasoning::ZBuffering< ModelT, SceneT >::computeDepthMap(), pcl::ESFEstimation< PointInT, PointOutT >::computeESF(), pcl::PFHRGBEstimation< PointInT, PointNT, PointOutT >::computeFeature(), pcl::IntensityGradientEstimation< PointInT, PointNT, PointOutT, IntensitySelectorT >::computeFeature(), pcl::ESFEstimation< PointInT, PointOutT >::computeFeature(), pcl::MomentInvariantsEstimation< PointInT, PointOutT >::computeFeature(), pcl::SHOTEstimationOMP< PointInT, PointNT, PointOutT, PointRFT >::computeFeature(), pcl::PrincipalCurvaturesEstimation< PointInT, PointNT, PointOutT >::computeFeature(), pcl::DifferenceOfNormalsEstimation< PointInT, PointNT, PointOutT >::computeFeature(), pcl::LinearLeastSquaresNormalEstimation< PointInT, PointOutT >::computeFeature(), pcl::GFPFHEstimation< PointInT, PointLT, PointOutT >::computeFeature(), pcl::IntensitySpinEstimation< PointInT, PointOutT >::computeFeature(), pcl::RIFTEstimation< PointInT, GradientT, PointOutT >::computeFeature(), pcl::NormalBasedSignatureEstimation< PointT, PointNT, PointFeature >::computeFeature(), pcl::UniqueShapeContext< PointInT, PointOutT, PointRFT >::computeFeature(), pcl::BoundaryEstimation< PointInT, PointNT, PointOutT >::computeFeature(), pcl::PFHEstimation< PointInT, PointNT, PointOutT >::computeFeature(), pcl::SHOTColorEstimationOMP< PointInT, PointNT, PointOutT, PointRFT >::computeFeature(), pcl::FPFHEstimation< PointInT, PointNT, PointOutT >::computeFeature(), pcl::RSDEstimation< PointInT, PointNT, PointOutT >::computeFeature(), pcl::SpinImageEstimation< PointInT, PointNT, PointOutT >::computeFeature(), pcl::SHOTEstimation< PointInT, PointNT, PointOutT, PointRFT >::computeFeature(), pcl::NormalEstimation< PointInT, PointOutT >::computeFeature(), pcl::SHOTColorEstimation< PointInT, PointNT, PointOutT, PointRFT >::computeFeature(), pcl::IntegralImageNormalEstimation< PointInT, PointOutT >::computeFeaturePart(), pcl::IntensitySpinEstimation< PointInT, PointOutT >::computeIntensitySpinImage(), pcl::ColorGradientModality< PointInT >::computeMaxColorGradients(), pcl::ColorGradientModality< PointInT >::computeMaxColorGradientsSobel(), pcl::FPFHEstimation< PointInT, PointNT, PointOutT >::computePairFeatures(), pcl::PFHEstimation< PointInT, PointNT, PointOutT >::computePairFeatures(), pcl::MomentInvariantsEstimation< PointInT, PointOutT >::computePointMomentInvariants(), pcl::PFHEstimation< PointInT, PointNT, PointOutT >::computePointPFHSignature(), pcl::PrincipalCurvaturesEstimation< PointInT, PointNT, PointOutT >::computePointPrincipalCurvatures(), pcl::VFHEstimation< PointInT, PointNT, PointOutT >::computePointSPFHSignature(), pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::computeRFAndShapeDistribution(), pcl::PFHRGBEstimation< PointInT, PointNT, PointOutT >::computeRGBPairFeatures(), pcl::RIFTEstimation< PointInT, GradientT, PointOutT >::computeRIFT(), pcl::CRHAlignment< PointT, nbins_ >::computeRollAngle(), pcl::LineRGBD< PointXYZT, PointRGBT >::computeTransformedTemplatePoints(), pcl::concatenateFields(), pcl::io::OrganizedConversion< PointT, false >::convert(), pcl::io::OrganizedConversion< PointT, true >::convert(), pcl::visualization::ImageViewer::convertRGBCloudToUChar(), pcl::GaussianKernel::convolveCols(), pcl::GaussianKernel::convolveRows(), pcl::copyPointCloud(), pcl::CPPFEstimation< PointInT, PointNT, PointOutT >::CPPFEstimation(), pcl::LineRGBD< PointXYZT, PointRGBT >::createAndAddTemplate(), pcl::visualization::createPolygon(), pcl::demeanPointCloud(), pcl::tracking::PyramidalKLTTracker< PointInT, IntensityT >::derivatives(), pcl::SmoothedSurfacesKeypoint< PointT, PointNT >::detectKeypoints(), pcl::HarrisKeypoint6D< PointInT, PointOutT, NormalT >::detectKeypoints(), pcl::SIFTKeypoint< PointInT, PointOutT >::detectKeypoints(), pcl::HarrisKeypoint3D< PointInT, PointOutT, NormalT >::detectKeypoints(), pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT >::detectKeypoints(), pcl::MultiscaleFeaturePersistence< PointSource, PointFeature >::determinePersistentFeatures(), pcl::GeneralizedIterativeClosestPoint< PointSource, PointTarget >::OptimizationFunctorWithIndices::df(), pcl::registration::TransformationEstimationDQ< PointSource, PointTarget, Scalar >::estimateRigidTransformation(), pcl::registration::TransformationEstimationDualQuaternion< PointSource, PointTarget, Scalar >::estimateRigidTransformation(), pcl::registration::TransformationEstimation2D< PointSource, PointTarget, Scalar >::estimateRigidTransformation(), pcl::registration::TransformationEstimationPointToPlaneLLS< PointSource, PointTarget, Scalar >::estimateRigidTransformation(), pcl::registration::TransformationEstimationPointToPlaneLLSWeighted< PointSource, PointTarget, Scalar >::estimateRigidTransformation(), pcl::registration::TransformationEstimationSVD< PointSource, PointTarget, Scalar >::estimateRigidTransformation(), pcl::registration::TransformationEstimationLM< PointSource, PointTarget, MatScalar >::estimateRigidTransformation(), pcl::registration::TransformationEstimationPointToPlaneWeighted< PointSource, PointTarget, MatScalar >::estimateRigidTransformation(), pcl::io::PointCloudImageExtractor< PointT >::extract(), pcl::ApproximateProgressiveMorphologicalFilter< PointT >::extract(), pcl::ism::ImplicitShapeModelEstimation< FeatureSize, PointT, NormalT >::extractDescriptors(), pcl::extractEuclideanClusters(), pcl::io::PointCloudImageExtractorWithScaling< PointT >::extractImpl(), pcl::io::PointCloudImageExtractorFromNormalField< PointT >::extractImpl(), pcl::io::PointCloudImageExtractorFromRGBField< PointT >::extractImpl(), pcl::io::PointCloudImageExtractorFromLabelField< PointT >::extractImpl(), pcl::extractLabeledEuclideanClusters(), pcl::people::GroundBasedPeopleDetectionApp< PointT >::extractRGBFromPointCloud(), pcl::GeneralizedIterativeClosestPoint< PointSource, PointTarget >::OptimizationFunctorWithIndices::fdf(), pcl::occlusion_reasoning::ZBuffering< ModelT, SceneT >::filter(), pcl::occlusion_reasoning::filter(), pcl::CVFHEstimation< PointInT, PointNT, PointOutT >::filterNormalsWithHighCurvature(), pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::filterNormalsWithHighCurvature(), pcl::ism::ImplicitShapeModelEstimation< FeatureSize, PointT, NormalT >::findObjects(), pcl::features::ISMVoteList< PointT >::findStrongestPeaks(), pcl::ApproximateVoxelGrid< PointT >::flush(), pcl::fromPCLPointCloud2(), pcl::PCDWriter::generateHeader(), pcl::getApproximateIndices(), pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT >::getBoundaryPoints(), pcl::features::ISMVoteList< PointT >::getColoredCloud(), pcl::RegionGrowing< PointT, NormalT >::getColoredCloud(), pcl::RegionGrowing< PointT, NormalT >::getColoredCloudRGBA(), pcl::features::ISMVoteList< PointT >::getDensityAtPoint(), pcl::MomentOfInertiaEstimation< PointT >::getEccentricity(), pcl::getFeaturePointCloud(), pcl::Registration< PointSource, PointTarget, Scalar >::getFitnessScore(), pcl::getMaxDistance(), pcl::getMaxSegment(), pcl::getMinMax3D(), pcl::TrajkovicKeypoint2D< PointInT, PointOutT, IntensityT >::getNumberOfThreads(), pcl::TrajkovicKeypoint3D< PointInT, PointOutT, NormalT >::getNumberOfThreads(), pcl::features::ISMVoteList< PointT >::getNumberOfVotes(), pcl::occlusion_reasoning::getOccludedCloud(), pcl::getPointCloudDifference(), pcl::getPointsInBox(), pcl::outofcore::OutofcoreOctreeDiskContainer< PointT >::insertRange(), pcl::BoundaryEstimation< PointInT, PointNT, PointOutT >::isBoundaryPoint(), pcl::isPointIn2DPolygon(), pcl::isXYPointIn2DXYPolygon(), pcl::LineRGBD< PointXYZT, PointRGBT >::loadTemplates(), pcl::TextureMapping< PointInT >::mapMultipleTexturesToMeshUV(), pcl::tracking::PyramidalKLTTracker< PointInT, IntensityT >::mismatchVector(), pcl::KdTree< FeatureT >::nearestKSearch(), pcl::search::Search< PointT >::nearestKSearch(), pcl::VoxelGridCovariance< PointTarget >::nearestKSearch(), pcl::registration::TransformationEstimationPointToPlaneWeighted< PointSource, PointTarget, MatScalar >::OptimizationFunctor::operator()(), pcl::registration::TransformationEstimationLM< PointSource, PointTarget, MatScalar >::OptimizationFunctor::operator()(), pcl::registration::TransformationEstimationPointToPlaneWeighted< PointSource, PointTarget, MatScalar >::OptimizationFunctorWithIndices::operator()(), pcl::GeneralizedIterativeClosestPoint< PointSource, PointTarget >::OptimizationFunctorWithIndices::operator()(), pcl::registration::TransformationEstimationLM< PointSource, PointTarget, MatScalar >::OptimizationFunctorWithIndices::operator()(), pcl::PointCloud< ModelT >::operator+=(), pcl::operator<<(), pcl::BilateralUpsampling< PointInT, PointOutT >::performProcessing(), pcl::Poisson< PointNT >::performReconstruction(), pcl::ConcaveHull< PointInT >::performReconstruction(), pcl::GridProjection< PointNT >::performReconstruction(), pcl::MarchingCubes< PointNT >::performReconstruction(), pcl::ConvexHull< PointInT >::performReconstruction2D(), pcl::ConvexHull< PointInT >::performReconstruction3D(), pcl::PointCloud< ModelT >::PointCloud(), pcl::PointCloudDepthAndRGBtoXYZRGBA(), pcl::PointCloudRGBtoI(), pcl::io::pointCloudTovtkPolyData(), pcl::PointCloudXYZRGBAtoXYZHSV(), pcl::PointCloudXYZRGBtoXYZHSV(), pcl::PointCloudXYZRGBtoXYZI(), pcl::PPFEstimation< PointInT, PointNT, PointOutT >::PPFEstimation(), pcl::PPFRGBEstimation< PointInT, PointNT, PointOutT >::PPFRGBEstimation(), pcl::PPFRGBRegionEstimation< PointInT, PointNT, PointOutT >::PPFRGBRegionEstimation(), pcl::CloudSurfaceProcessing< PointInT, PointOutT >::process(), pcl::BilateralUpsampling< PointInT, PointOutT >::process(), pcl::MovingLeastSquares< PointInT, PointOutT >::process(), pcl::SampleConsensusModelLine< PointT >::projectPoints(), pcl::SampleConsensusModelStick< PointT >::projectPoints(), pcl::SampleConsensusModelCircle3D< PointT >::projectPoints(), pcl::SampleConsensusModelCircle2D< PointT >::projectPoints(), pcl::SampleConsensusModelSphere< PointT >::projectPoints(), pcl::SampleConsensusModelCylinder< PointT, PointNT >::projectPoints(), pcl::SampleConsensusModelPlane< PointT >::projectPoints(), pcl::SampleConsensusModelCone< PointT, PointNT >::projectPoints(), pcl::PCDGrabber< PointT >::publish(), pcl::KdTreeFLANN< PointT, Dist >::radiusSearch(), pcl::octree::OctreePointCloudSearch< PointT, LeafContainerT, BranchContainerT >::radiusSearch(), pcl::KdTree< FeatureT >::radiusSearch(), pcl::search::Search< PointT >::radiusSearch(), pcl::VoxelGridCovariance< PointTarget >::radiusSearch(), pcl::io::LZFDepth16ImageReader::read(), pcl::io::LZFRGB24ImageReader::read(), pcl::io::LZFYUV422ImageReader::read(), pcl::io::LZFBayer8ImageReader::read(), pcl::io::LZFDepth16ImageReader::readOMP(), pcl::io::LZFRGB24ImageReader::readOMP(), pcl::io::LZFYUV422ImageReader::readOMP(), pcl::io::LZFBayer8ImageReader::readOMP(), pcl::outofcore::OutofcoreOctreeDiskContainer< PointT >::readRange(), pcl::ConcaveHull< PointInT >::reconstruct(), pcl::ConvexHull< PointInT >::reconstruct(), pcl::HarrisKeypoint3D< PointInT, PointOutT, NormalT >::refineCorners(), pcl::removeNaNFromPointCloud(), pcl::removeNaNNormalsFromPointCloud(), pcl::HarrisKeypoint3D< PointInT, PointOutT, NormalT >::responseCurvature(), pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::responseHarris(), pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::responseLowe(), pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::responseNoble(), pcl::HarrisKeypoint6D< PointInT, PointOutT, NormalT >::responseTomasi(), pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::responseTomasi(), pcl::seededHueSegmentation(), pcl::OrganizedConnectedComponentSegmentation< PointT, PointLT >::segment(), pcl::SegmentDifferences< PointT >::segment(), pcl::ExtractPolygonalPrismData< PointT >::segment(), pcl::OrganizedMultiPlaneSegmentation< PointT, PointNT, PointLT >::segment(), pcl::OrganizedMultiPlaneSegmentation< PointT, PointNT, PointLT >::segmentAndRefine(), pcl::PlanarPolygon< PointT >::setContour(), pcl::PPFHashMapSearch::setInputFeatureCloud(), pcl::tracking::PyramidalKLTTracker< PointInT, IntensityT >::setPointsToTrack(), pcl::ism::ImplicitShapeModelEstimation< FeatureSize, PointT, NormalT >::shiftCloud(), pcl::features::ISMVoteList< PointT >::shiftMean(), pcl::TextureMapping< PointInT >::showOcclusions(), pcl::ism::ImplicitShapeModelEstimation< FeatureSize, PointT, NormalT >::simplifyCloud(), pcl::TextureMapping< PointInT >::sortFacesByCamera(), pcl::tracking::PyramidalKLTTracker< PointInT, IntensityT >::spatialGradient(), pcl::PointCloud< ModelT >::swap(), pcl::people::GroundBasedPeopleDetectionApp< PointT >::swapDimensions(), pcl::toPCLPointCloud2(), pcl::tracking::PyramidalKLTTracker< PointInT, IntensityT >::track(), pcl::transformPointCloud(), pcl::transformPointCloudWithNormals(), pcl::visualization::PCLVisualizer::updateCorrespondences(), pcl::visualization::PCLHistogramVisualizer::updateFeatureHistogram(), pcl::visualization::PCLVisualizer::updatePointCloud(), pcl::visualization::PCLVisualizer::updatePolygonMesh(), pcl::registration::TransformationValidationEuclidean< PointSource, PointTarget, Scalar >::validateTransformation(), pcl::features::ISMVoteList< PointT >::validateTree(), pcl::ESFEstimation< PointInT, PointOutT >::voxelize9(), pcl::io::vtkPolyDataToPointCloud(), pcl::io::vtkStructuredGridToPointCloud(), pcl::PCDWriter::writeASCII(), pcl::PCDWriter::writeBinary(), pcl::PCDWriter::writeBinaryCompressed(), and pcl::outofcore::OutofcoreOctreeDiskContainer< PointT >::~OutofcoreOctreeDiskContainer().

template<typename PointT>

Eigen::Quaternionf pcl::PointCloud< PointT >::sensor_orientation_

Sensor acquisition pose (rotation).

Definition at line 423 of file point_cloud.h.

Referenced by pcl::visualization::PCLVisualizer::addPointCloud(), pcl::visualization::PCLVisualizer::addPolygonMesh(), pcl::IntegralImageNormalEstimation< PointInT, PointOutT >::computeFeature(), pcl::copyPointCloud(), pcl::Filter< pcl::PointXYZRGBL >::filter(), pcl::PCDWriter::generateHeader(), pcl::operator<<(), pcl::PCDGrabber< PointT >::operator[](), pcl::ImageGrabber< PointT >::operator[](), pcl::PCDGrabber< PointT >::publish(), pcl::ImageGrabber< PointT >::publish(), pcl::IFSReader::read(), pcl::FileReader::read(), pcl::PLYReader::read(), pcl::PCDReader::read(), pcl::io::LZFDepth16ImageReader::read(), pcl::OBJReader::read(), pcl::io::LZFDepth16ImageReader::readOMP(), pcl::PointCloud< ModelT >::swap(), pcl::transformPointCloud(), pcl::transformPointCloudWithNormals(), pcl::FileWriter::write(), and pcl::PLYWriter::write().

template<typename PointT>

Eigen::Vector4f pcl::PointCloud< PointT >::sensor_origin_

Sensor acquisition pose (origin/translation).

Definition at line 421 of file point_cloud.h.

Referenced by pcl::visualization::PCLVisualizer::addPointCloud(), pcl::visualization::PCLVisualizer::addPolygonMesh(), pcl::IntegralImageNormalEstimation< PointInT, PointOutT >::computeFeature(), pcl::copyPointCloud(), pcl::Filter< pcl::PointXYZRGBL >::filter(), pcl::PCDWriter::generateHeader(), pcl::operator<<(), pcl::PCDGrabber< PointT >::operator[](), pcl::ImageGrabber< PointT >::operator[](), pcl::PCDGrabber< PointT >::publish(), pcl::ImageGrabber< PointT >::publish(), pcl::IFSReader::read(), pcl::FileReader::read(), pcl::PLYReader::read(), pcl::PCDReader::read(), pcl::io::LZFDepth16ImageReader::read(), pcl::OBJReader::read(), pcl::io::LZFDepth16ImageReader::readOMP(), pcl::PointCloud< ModelT >::swap(), pcl::transformPointCloud(), pcl::transformPointCloudWithNormals(), pcl::FileWriter::write(), and pcl::PLYWriter::write().

template<typename PointT>

uint32_t pcl::PointCloud< PointT >::width

The point cloud width (if organized as an image-structure).

Definition at line 413 of file point_cloud.h.

Referenced by pcl::visualization::PCLVisualizer::addPointCloudNormals(), pcl::visualization::ImageViewer::addRGBImage(), pcl::Registration< PointSource, PointTarget, Scalar >::align(), pcl::FastBilateralFilterOMP< PointT >::applyFilter(), pcl::LocalMaximum< PointT >::applyFilter(), pcl::MedianFilter< PointT >::applyFilter(), pcl::FastBilateralFilter< PointT >::applyFilter(), pcl::GridMinimum< PointT >::applyFilter(), pcl::ShadowPoints< PointT, NormalT >::applyFilter(), pcl::SamplingSurfaceNormal< PointT >::applyFilter(), pcl::ProjectInliers< PointT >::applyFilter(), pcl::CovarianceSampling< PointT, PointNT >::applyFilter(), pcl::ApproximateVoxelGrid< PointT >::applyFilter(), pcl::VoxelGrid< PointT >::applyFilter(), pcl::VoxelGridCovariance< PointT >::applyFilter(), pcl::ConditionalRemoval< PointT >::applyFilter(), pcl::LineRGBD< PointXYZT, PointRGBT >::applyProjectiveDepthICPOnDetections(), pcl::RangeImageBorderExtractor::calculateBorderDirection(), pcl::RangeImageBorderExtractor::calculateMainPrincipalCurvature(), pcl::RangeImageBorderExtractor::changeScoreAccordingToShadowBorderValue(), pcl::RangeImageBorderExtractor::checkIfMaximum(), pcl::RangeImageBorderExtractor::checkPotentialBorder(), pcl::ESFEstimation< PointInT, PointOutT >::compute(), pcl::GFPFHEstimation< PointInT, PointLT, PointOutT >::compute(), pcl::filters::Pyramid< PointT >::compute(), pcl::VFHEstimation< PointInT, PointNT, PointOutT >::compute(), pcl::CVFHEstimation< PointInT, PointNT, PointOutT >::compute(), pcl::Feature< PointInT, PointOutT >::compute(), pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::compute(), pcl::SurfaceNormalModality< PointInT >::computeAndQuantizeSurfaceNormals(), pcl::ESFEstimation< PointInT, PointOutT >::computeFeature(), pcl::GFPFHEstimation< PointInT, PointLT, PointOutT >::computeFeature(), pcl::IntensitySpinEstimation< PointInT, PointOutT >::computeFeature(), pcl::RIFTEstimation< PointInT, GradientT, PointOutT >::computeFeature(), pcl::RSDEstimation< PointInT, PointNT, PointOutT >::computeFeature(), pcl::IntegralImageNormalEstimation< PointInT, PointOutT >::computeFeatureFull(), pcl::IntegralImageNormalEstimation< PointInT, PointOutT >::computeFeaturePart(), pcl::ColorGradientModality< PointInT >::computeMaxColorGradients(), pcl::ColorGradientModality< PointInT >::computeMaxColorGradientsSobel(), pcl::VFHEstimation< PointInT, PointNT, PointOutT >::computePointSPFHSignature(), pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::computeRFAndShapeDistribution(), pcl::LineRGBD< PointXYZT, PointRGBT >::computeTransformedTemplatePoints(), pcl::concatenateFields(), pcl::io::OrganizedConversion< PointT, false >::convert(), pcl::io::OrganizedConversion< PointT, true >::convert(), pcl::GaussianKernel::convolve(), pcl::filters::Convolution3D< PointIn, PointOut, KernelT >::convolve(), pcl::GaussianKernel::convolveCols(), pcl::GaussianKernel::convolveRows(), pcl::copyPointCloud(), pcl::CPPFEstimation< PointInT, PointNT, PointOutT >::CPPFEstimation(), pcl::common::deleteCols(), pcl::common::deleteRows(), pcl::demeanPointCloud(), pcl::tracking::PyramidalKLTTracker< PointInT, IntensityT >::derivatives(), pcl::SmoothedSurfacesKeypoint< PointT, PointNT >::detectKeypoints(), pcl::HarrisKeypoint6D< PointInT, PointOutT, NormalT >::detectKeypoints(), pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::detectKeypoints(), pcl::TrajkovicKeypoint2D< PointInT, PointOutT, IntensityT >::detectKeypoints(), pcl::TrajkovicKeypoint3D< PointInT, PointOutT, NormalT >::detectKeypoints(), pcl::HarrisKeypoint3D< PointInT, PointOutT, NormalT >::detectKeypoints(), pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT >::detectKeypoints(), pcl::MultiscaleFeaturePersistence< PointSource, PointFeature >::determinePersistentFeatures(), pcl::tracking::PyramidalKLTTracker< PointInT, IntensityT >::downsample(), pcl::common::duplicateColumns(), pcl::common::duplicateRows(), pcl::estimateProjectionMatrix(), pcl::common::expandColumns(), pcl::common::expandRows(), pcl::io::PointCloudImageExtractor< PointT >::extract(), pcl::io::PointCloudImageExtractorWithScaling< PointT >::extractImpl(), pcl::io::PointCloudImageExtractorFromNormalField< PointT >::extractImpl(), pcl::io::PointCloudImageExtractorFromRGBField< PointT >::extractImpl(), pcl::io::PointCloudImageExtractorFromLabelField< PointT >::extractImpl(), pcl::people::GroundBasedPeopleDetectionApp< PointT >::extractRGBFromPointCloud(), pcl::common::CloudGenerator< PointT, GeneratorT >::fill(), pcl::common::CloudGenerator< pcl::PointXY, GeneratorT >::fill(), pcl::occlusion_reasoning::filter(), pcl::CVFHEstimation< PointInT, PointNT, PointOutT >::filterNormalsWithHighCurvature(), pcl::fromPCLPointCloud2(), pcl::PCDWriter::generateHeader(), pcl::features::ISMVoteList< PointT >::getColoredCloud(), pcl::RegionGrowing< PointT, NormalT >::getColoredCloud(), pcl::RegionGrowing< PointT, NormalT >::getColoredCloudRGBA(), pcl::MomentOfInertiaEstimation< PointT >::getEccentricity(), pcl::occlusion_reasoning::getOccludedCloud(), pcl::getPointCloudDifference(), pcl::filters::Convolution< PointIn, PointOut >::initCompute(), pcl::outofcore::OutofcoreOctreeDiskContainer< PointT >::insertRange(), pcl::common::mirrorColumns(), pcl::common::mirrorRows(), pcl::tracking::PyramidalKLTTracker< PointInT, IntensityT >::mismatchVector(), pcl::operator<<(), pcl::BilateralUpsampling< PointInT, PointOutT >::performProcessing(), pcl::ConcaveHull< PointInT >::performReconstruction(), pcl::GridProjection< PointNT >::performReconstruction(), pcl::MarchingCubes< PointNT >::performReconstruction(), pcl::ConvexHull< PointInT >::performReconstruction2D(), pcl::ConvexHull< PointInT >::performReconstruction3D(), pcl::PointCloudDepthAndRGBtoXYZRGBA(), pcl::PointCloudRGBtoI(), pcl::io::pointCloudTovtkStructuredGrid(), pcl::PointCloudXYZRGBAtoXYZHSV(), pcl::PointCloudXYZRGBtoXYZHSV(), pcl::PointCloudXYZRGBtoXYZI(), pcl::PPFEstimation< PointInT, PointNT, PointOutT >::PPFEstimation(), pcl::PPFRGBEstimation< PointInT, PointNT, PointOutT >::PPFRGBEstimation(), pcl::CloudSurfaceProcessing< PointInT, PointOutT >::process(), pcl::BilateralUpsampling< PointInT, PointOutT >::process(), pcl::MovingLeastSquares< PointInT, PointOutT >::process(), pcl::ColorGradientModality< PointInT >::processInputData(), pcl::SampleConsensusModelLine< PointT >::projectPoints(), pcl::SampleConsensusModelStick< PointT >::projectPoints(), pcl::SampleConsensusModelCircle3D< PointT >::projectPoints(), pcl::SampleConsensusModelCircle2D< PointT >::projectPoints(), pcl::SampleConsensusModelSphere< PointT >::projectPoints(), pcl::SampleConsensusModelCylinder< PointT, PointNT >::projectPoints(), pcl::SampleConsensusModelPlane< PointT >::projectPoints(), pcl::SampleConsensusModelCone< PointT, PointNT >::projectPoints(), pcl::PCDGrabber< PointT >::publish(), pcl::outofcore::OutofcoreOctreeBaseNode< ContainerT, PointT >::queryBBIncludes(), pcl::io::LZFDepth16ImageReader::read(), pcl::io::LZFRGB24ImageReader::read(), pcl::io::LZFYUV422ImageReader::read(), pcl::io::LZFBayer8ImageReader::read(), pcl::io::LZFDepth16ImageReader::readOMP(), pcl::io::LZFRGB24ImageReader::readOMP(), pcl::io::LZFYUV422ImageReader::readOMP(), pcl::io::LZFBayer8ImageReader::readOMP(), pcl::ConcaveHull< PointInT >::reconstruct(), pcl::ConvexHull< PointInT >::reconstruct(), pcl::SurfaceReconstruction< PointInT >::reconstruct(), pcl::removeNaNFromPointCloud(), pcl::removeNaNNormalsFromPointCloud(), pcl::HarrisKeypoint3D< PointInT, PointOutT, NormalT >::responseCurvature(), pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::responseHarris(), pcl::HarrisKeypoint3D< PointInT, PointOutT, NormalT >::responseHarris(), pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::responseLowe(), pcl::HarrisKeypoint3D< PointInT, PointOutT, NormalT >::responseLowe(), pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::responseNoble(), pcl::HarrisKeypoint3D< PointInT, PointOutT, NormalT >::responseNoble(), pcl::HarrisKeypoint6D< PointInT, PointOutT, NormalT >::responseTomasi(), pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::responseTomasi(), pcl::HarrisKeypoint3D< PointInT, PointOutT, NormalT >::responseTomasi(), pcl::OrganizedConnectedComponentSegmentation< PointT, PointLT >::segment(), pcl::SegmentDifferences< PointT >::segment(), pcl::visualization::ImageViewer::showCorrespondences(), pcl::tracking::PyramidalKLTTracker< PointInT, IntensityT >::spatialGradient(), pcl::PointCloud< ModelT >::swap(), pcl::people::GroundBasedPeopleDetectionApp< PointT >::swapDimensions(), pcl::toPCLPointCloud2(), pcl::tracking::PyramidalKLTTracker< PointInT, IntensityT >::track(), pcl::transformPointCloud(), pcl::transformPointCloudWithNormals(), pcl::RangeImageBorderExtractor::updatedScoreAccordingToNeighborValues(), pcl::io::vtkPolyDataToPointCloud(), pcl::io::vtkStructuredGridToPointCloud(), pcl::PCDWriter::writeASCII(), and pcl::outofcore::OutofcoreOctreeDiskContainer< PointT >::~OutofcoreOctreeDiskContainer().

The documentation for this class was generated from the following files:

- /build/pcl-0nnAvv/pcl-1.7.2/common/include/pcl/common/projection_matrix.h
- /build/pcl-0nnAvv/pcl-1.7.2/common/include/pcl/point_cloud.h